package apfel.calc;

public class LocalApfelCalculator implements ApfelCalculator {

  public LocalApfelCalculator() {
  }

  public static int checkC(double reC, double imC, int iterations) {
    double reZ = 0.0D;
    double imZ = 0.0D;
    double reZ_minus1 = 0.0D;
    double imZ_minus1 = 0.0D;
    int i;
    for (i = 0; i < iterations; i++) {
      imZ = 2D * reZ_minus1 * imZ_minus1 + imC;
      reZ = (reZ_minus1 * reZ_minus1 - imZ_minus1 * imZ_minus1) + reC;
      if (reZ * reZ + imZ * imZ > 4D)
        return i;
      reZ_minus1 = reZ;
      imZ_minus1 = imZ;
    }

    return i;
  }

  public int[][] calcMandelbrot(double reStart, double reStep, int reNumber,
      double imStart, double imStep, int imNumber, int max_iterations)
      throws ApfelCalculatorException {
    int[][] ret = new int[reNumber][imNumber];

    double imC = imStart;
    for (int y = 0; y < imNumber; y++) {
      double reC = reStart;
      int x;
      for (x = 0; x < reNumber; x++) {
        ret[x][y] = checkC(reC, imC, max_iterations);
        reC += reStep;
      }

      imC += imStep;
    }

    return (ret);
  }

}
